import { Dialect } from "./dialect";
export declare abstract class Statement {
    operation: string;
    table: string;
    text: string;
    values: any[];
    abstract dialect: Dialect;
    static fromFactory(dialect: Dialect): MysqlStatement | MssqlStatement | PostgresStatement;
    join(table: string, fields: Object, type?: string): this;
    where(fields: Object, operator?: string, separator?: string): this;
    and(fields: Object, operator?: string, separator?: string): this;
    or(fields: Object, operator?: string, separator?: string): this;
    groupby(columns: string | string[]): this;
    having(fields: Object, operator?: string, separator?: string): this;
    orderby(columns: string | string[]): this;
    returning(columns: string | string[]): this;
    toString(): string;
    abstract limit(limit: number, offset: number): Statement;
}
export declare class PostgresStatement extends Statement {
    dialect: Dialect;
    limit(limit: number, offset: number | undefined): Statement;
}
export declare class MysqlStatement extends Statement {
    dialect: Dialect;
    limit(limit: number, offset: number): Statement;
}
export declare class MssqlStatement extends Statement {
    dialect: Dialect;
    limit(limit: number, offset: number): Statement;
}
